//+------------------------------------------------------------------+
//|                                                 Multi_M_Main.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "bobfourie"

extern string ____Money_Management____   = "";
extern double dLots                      = 0.01;
extern bool   UseMoneyMgmt               = false;
extern double RiskPercentPerPair         = 2;
extern bool bTargetOnEquity              = true;
extern double dPercentTarget             =10;
extern bool bAutoSL                      = false;
extern bool bAutoTP                      = false;
extern int iATR_Period                   =14;

extern string Sum_of_Signal_for_Open_close = "___________________________________________________";
extern int iSum_Signal = 2;

extern string ________CHFJPY_________    = "___________________________________________________";
extern bool   PermitOrdersCHFJPY         = true;
extern double StopLossCHFJPY             = 0;
extern double TakeProfitCHFJPY           = 0;
extern double TrailingStopCHFJPY         = 47; 

extern string ________EURCHF__________   = "___________________________________________________";
extern bool   PermitOrdersEURCHF         = true;
extern double StopLossEURCHF             = 0;
extern double TakeProfitEURCHF           = 0;
extern double TrailingStopEURCHF         = 47; 

extern string ________EURGBP_________    = "___________________________________________________";
extern bool   PermitOrdersEURGBP         = true;
extern double StopLossEURGBP             = 0;
extern double TakeProfitEURGBP           = 0;
extern double TrailingStopEURGBP         = 47; 

extern string ________EURJPY_________    = "___________________________________________________";
extern bool   PermitOrdersEURJPY         = true;
extern double StopLossEURJPY             = 0;
extern double TakeProfitEURJPY           = 0;
extern double TrailingStopEURJPY         = 47; 

extern string ________EURUSD__________   = "___________________________________________________";
extern bool   PermitOrdersEURUSD         = true;
extern double StopLossEURUSD             = 0;
extern double TakeProfitEURUSD           = 0;
extern double TrailingStopEURUSD         = 47; 

extern string ________GBPCHF__________   = "___________________________________________________";
extern bool   PermitOrdersGBPCHF         = true;
extern double StopLossGBPCHF             = 0;
extern double TakeProfitGBPCHF           = 0;
extern double TrailingStopGBPCHF         = 47; 

extern string ________GBPJPY__________   = "___________________________________________________";
extern bool   PermitOrdersGBPJPY         = true;
extern double StopLossGBPJPY             = 0;
extern double TakeProfitGBPJPY           = 0;
extern double TrailingStopGBPJPY         = 47; 

extern string ________GBPUSD__________   = "___________________________________________________";
extern bool   PermitOrdersGBPUSD         = true;
extern double StopLossGBPUSD             = 0;
extern double TakeProfitGBPUSD           = 0;
extern double TrailingStopGBPUSD         = 47; 

extern string ________USDCHF__________   = "___________________________________________________";
extern bool   PermitOrdersUSDCHF         = true;
extern double StopLossUSDCHF             = 0;
extern double TakeProfitUSDCHF           = 0;
extern double TrailingStopUSDCHF         = 47; 

extern string ________USDJPY__________   = "___________________________________________________";
extern bool   PermitOrdersUSDJPY         = true;
extern double StopLossUSDJPY             = 0;
extern double TakeProfitUSDJPY           = 0;
extern double TrailingStopUSDJPY         = 47; 

extern string _________RSI_________      = "___________________________________________________";
extern int iRSI_Period                   = 14;
extern int iRSI_Up                       = 53;
extern int iRSI_Down                     = 47;

extern string _________CCI_________      = "___________________________________________________";
extern int iCCI_Period                   = 14;//50;

extern string _____Moving_Average_____   = "MODE: 0=SMA, 1=EMA, 2=SMMA, 3=LWMA ";
extern int iMODE_MA                      = 0; //0=SMA, 1=EMA, 2=SMMA, 3=LWMA
extern int iMA_Periode                   = 5;

extern string _____Stochastic______      = "___________________________________________________";
extern int iK_Period                     = 14;
extern int iD_Period                     = 3;
extern int iSlowing_Period               = 4;
extern int iStoch_Up                     = 53;
extern int iStoch_Down                   = 47;

extern string _____Miscellaneous______   = "___________________________________________________";
extern int iTimeFrame = 0;//What TF to use
extern int iMagic = 211;
extern string sComment = "Multi Curr";

#import "mylib.ex4" 
   void PrintArray(string array[][]);
   void Trade(string sSymbol,int iType, double Lots, double dLevel,double Stoploss, double TakeProfit, int MagicNumber, string sComment);
   void Trailing(string s,int TrailingStop);
   double GetLots(string sSymbol, double Lots, bool UseMoneyMgmt, double RiskPercent, bool BrokerPermitsFractionalLots);
   bool ISOrderExist(string s);
   void CloseAllOrders(string s);
   void Stepper(string s,int StepStart,int StepSize);
   void Trailing(string s,int TrailingStop);
   void PopMDArray(string& sArray[][], string sData);
   int GetMagic(int iUniqueMagic,string sSymbol);
   string MiniCheck(string sSymbol);
   double GetLots(string sSymbol, double Lots, bool UseMoneyMgmt, double RiskPercent, bool BrokerPermitsFractionalLots);

int init()
  { return(0); }
int deinit()
  { return(0); }
int start()
  {
   //----------------Prepare Data---------------
   string sSymbols[10,6];
   PopMDArray(sSymbols,  "CHYJPY,-1,"+StopLossCHFJPY+","+TakeProfitCHFJPY+","+TrailingStopCHFJPY+","+PermitOrdersCHFJPY+
                        "|GBPJPY,-1,"+StopLossGBPJPY+","+TakeProfitGBPJPY+","+TrailingStopGBPJPY+","+PermitOrdersGBPJPY+
                        "|GBPUSD,-1,"+StopLossGBPUSD+","+TakeProfitGBPUSD+","+TrailingStopGBPUSD+","+PermitOrdersGBPUSD+
                        "|USDJPY,-1,"+StopLossUSDJPY+","+TakeProfitUSDJPY+","+TrailingStopUSDJPY+","+PermitOrdersUSDJPY+
                        "|USDCHF,-1,"+StopLossUSDCHF+","+TakeProfitUSDCHF+","+TrailingStopUSDCHF+","+PermitOrdersUSDCHF+
                        "|EURCHF,-1,"+StopLossEURCHF+","+TakeProfitEURCHF+","+TrailingStopEURCHF+","+PermitOrdersEURCHF+
                        "|EURGBP,-1,"+StopLossEURGBP+","+TakeProfitEURGBP+","+TrailingStopEURGBP+","+PermitOrdersEURGBP+
                        "|EURJPY,-1,"+StopLossEURJPY+","+TakeProfitEURJPY+","+TrailingStopEURJPY+","+PermitOrdersEURJPY+
                        "|EURUSD,-1,"+StopLossEURUSD+","+TakeProfitEURUSD+","+TrailingStopEURUSD+","+PermitOrdersEURUSD+
                        "|GBPCHF,-1,"+StopLossGBPCHF+","+TakeProfitGBPCHF+","+TrailingStopGBPCHF+","+PermitOrdersGBPCHF+
                        "");
   string sCurrency[5,2] = {"CHF","0","GBP","0","USD","0","JPY","0","EUR","0"};
   
   //Populate Array with signals for pairs
   PopulateArrays(iTimeFrame,iCCI_Period, iK_Period, iD_Period, iSlowing_Period, iRSI_Period, iMA_Periode, iMODE_MA,iRSI_Up, iRSI_Down, iStoch_Up, iStoch_Down, sSymbols, sCurrency);
   //----------------Prepare Data END------------- 

   //-----------------Trade -------------------------
   double dTLots = GetLots(Symbol(), dLots, UseMoneyMgmt,RiskPercentPerPair, true);
   for(int i = 0; i < ArrayRange(sSymbols,0) ; i++)
   {
      
    if(sSymbols[i,5] == "1")//If allowed to trade
    {
      if(StrToInteger(sSymbols[i,1]) == -1) Trailing("0,"+sSymbols[i,0]+",1,"+iMagic, StrToInteger(sSymbols[i,4]));
      
      //Buy
      if(StrToInteger(sSymbols[i,1]) == OP_BUY && !ISOrderExist("0,"+sSymbols[i,0]+",1,"+iMagic+",2,"+OP_BUY) )
      {
         if( GetMArrayValue(StringSubstr(sSymbols[i,0], 0, 3),sCurrency) >= iSum_Signal && GetMArrayValue(StringSubstr(sSymbols[i,0], 3, 3),sCurrency) <= -iSum_Signal)
         {
               CloseAllOrders("0,"+sSymbols[i,0]+",1,"+iMagic+",2,"+OP_SELL);
               Trade(sSymbols[i,0],OP_BUY, dTLots, 0, GetSLTP(sSymbols[i,0],0, iATR_Period , bAutoSL, StrToInteger(sSymbols[i,2])), GetSLTP(sSymbols[i,0],0, iATR_Period , bAutoTP, StrToInteger(sSymbols[i,3])), iMagic, sComment);
         }
      }
      
      //Sell
      if(StrToInteger(sSymbols[i,1]) == OP_SELL && !ISOrderExist("0,"+sSymbols[i,0]+",1,"+iMagic+",2,"+OP_SELL) )
      {
         if( GetMArrayValue(StringSubstr(sSymbols[i,0], 0, 3),sCurrency) <= -iSum_Signal && GetMArrayValue(StringSubstr(sSymbols[i,0], 3, 3),sCurrency) >= iSum_Signal)
         {
               CloseAllOrders("0,"+sSymbols[i,0]+",1,"+iMagic+",2,"+OP_BUY);
               Trade(sSymbols[i,0],OP_SELL, dTLots, 0, GetSLTP(sSymbols[i,0],0, iATR_Period , bAutoSL, StrToInteger(sSymbols[i,2])), GetSLTP(sSymbols[i,0],0, iATR_Period , bAutoTP, StrToInteger(sSymbols[i,3])), iMagic, sComment);
         }
      }
     }//end if true allowd to trade symbol
   }//end for
   //-----------------Trade END-----------------------
  
  static double dOldBalance = 0;
  if (bTargetOnEquity)
  {
   if(dOldBalance == 0)dOldBalance = AccountBalance();
   if(AccountEquity()>=dOldBalance+(dPercentTarget*dOldBalance/100))  CloseAllOrders("1,"+iMagic);
   //Comment("dOldBalance: "+dOldBalance+"\nAccountEquity: "+AccountEquity()+"\n"+(dOldBalance+(dPercentTarget*dOldBalance/100)));
  }
       
   //*/
   //------------------Comment----------------------
   string sOutput = "";
   for(int x = 0; x < ArrayRange(sCurrency,0) ; x++)
   {
      sOutput = sOutput + sCurrency[x,0]+": "+ sCurrency[x,1]+"\n";
   }
   for(int y = 0; y < ArrayRange(sSymbols,0) ; y++)
   {
      sOutput = sOutput + sSymbols[y,0]+": "+ GetStringType(sSymbols[y,1])+"\n";
   }
   Comment(sOutput);
   //------------------Comment END--------------------
   //*/
   
   //PrintArray(sSymbols);
   return(0);
  }
int GetSLTP(string sSymbol,int iTimeFrame,int iATR_Period , bool bAuto, int iCurrent)
{
   if(bAuto) return(iATR( MiniCheck(sSymbol), iTimeFrame, iATR_Period, 0) * 2 / MarketInfo(MiniCheck(sSymbol),MODE_POINT) ); 
   else return(iCurrent);
}
  
string GetStringType(string sType)
{
   if(sType == "0")return("Buy");
   if(sType == "1")return("Sell");
   return("-");
}
  
//Get [i,1] value with the the row value known
int GetMArrayValue(string sString, string& sArray[][])
{
   for(int i = 0; i < ArrayRange(sArray,0) ; i++)
   {
      if(sArray[i][0] == sString)return(StrToInteger(sArray[i][1]));
   }   
   return(0);
}

void PopulateArrays(int iTimeFrame,int iCCI_Period, int iK_Period, int iD_Period, int iSlowing_Period, int iRSI_Period, int iMA_Periode, int iMODE_MA,int iRSI_Up, int iRSI_Down, int iStoch_Up, int iStoch_Down, string& sSymbols[][],string& sCurrency[][])
{
      for(int i = 0; i < ArrayRange(sSymbols,0) ; i++)
   {
      sSymbols[i,1] = GetSignal(sSymbols[i,0] ,iTimeFrame,iCCI_Period, iK_Period, iD_Period, iSlowing_Period, iRSI_Period, iMA_Periode, iMODE_MA, iRSI_Up, iRSI_Down, iStoch_Up, iStoch_Down);
      
      for(int x = 0; x < ArrayRange(sCurrency,0) ; x++)
      {
         if(StringFind(sSymbols[i,0], sCurrency[x,0], 0) >= 0  && sSymbols[i,1] != "-1")
         {
            if(StrToInteger(sSymbols[i,1]) == OP_BUY)
            {
              if( StringSubstr(sSymbols[i,0], 0, 3) == sCurrency[x,0])sCurrency[x,1] = StrToInteger(sCurrency[x,1]) + 1;
              else sCurrency[x,1] = StrToInteger(sCurrency[x,1]) -1;
            }
            
            if(StrToInteger(sSymbols[i,1]) == OP_SELL)
            {
              if( StringSubstr(sSymbols[i,0], 0, 3) == sCurrency[x,0])sCurrency[x,1] = StrToInteger(sCurrency[x,1]) - 1;
              else sCurrency[x,1] = StrToInteger(sCurrency[x,1]) + 1;
            }
         }
      }
   } 
   //PrintArray(sSymbols);
  //PrintArray(sCurrency);
}  


int GetSignal(string sSymbol ,int iTimeFrame,int iCCI_Period, int iK_Period, int iD_Period, int iSlowing_Period, int iRSI_Period, int iMA_Periode, int iMODE_MA,int iRSI_Up, int iRSI_Down, int iStoch_Up, int iStoch_Down)
{
  sSymbol = MiniCheck(sSymbol);
  double cci = iCCI(sSymbol, iTimeFrame, iCCI_Period,PRICE_TYPICAL, 0);
  double prev_cci = iCCI(sSymbol, iTimeFrame, cci,PRICE_TYPICAL, 1);
  double Stoch = iStochastic(sSymbol, iTimeFrame, iK_Period,iD_Period,iSlowing_Period,MODE_SMA,0,MODE_MAIN,0);
  double SignStoch = iStochastic(sSymbol, iTimeFrame, iK_Period,iD_Period,iSlowing_Period,MODE_SMA,0,MODE_SIGNAL,0);
  double RSI = iRSI(sSymbol, iTimeFrame, iRSI_Period,PRICE_CLOSE,0);
  double MA = iMA(sSymbol, iTimeFrame, iMA_Periode,0,iMODE_MA,0,0);
  double prev_MA = iMA(sSymbol, iTimeFrame, iMA_Periode,0,iMODE_MA,0,1);

  if(cci > 0 && cci>prev_cci && RSI>iRSI_Up   && Stoch>iStoch_Up   && Stoch>SignStoch &&  iOpen(sSymbol,0,0)>MA && MA>prev_MA) return(OP_BUY); 
  if(cci < 0 && cci<prev_cci && RSI<iRSI_Down && Stoch<iStoch_Down && Stoch<SignStoch &&  iOpen(sSymbol,0,0)<MA && MA<prev_MA) return(OP_SELL);
  return(-1);
}


